import { ApplicationCommand, Snowflake } from "../definitions";
import { Optional } from "../interfaces";
export declare function getGlobalApplicationCommands(options?: {
    headers?: Record<string, string>;
    applicationID?: Snowflake;
}): Promise<ApplicationCommand[]>;
export declare function postGlobalApplicationCommand(command: Omit<ApplicationCommand, "id" | "application_id">, options?: {
    headers?: Record<string, string>;
    applicationID?: Snowflake;
}): Promise<ApplicationCommand>;
export declare function putGlobalApplicationCommands(commands: Array<Optional<ApplicationCommand, "id" | "application_id">>, options?: {
    headers?: Record<string, string>;
    applicationID?: Snowflake;
}): Promise<ApplicationCommand>;
export declare function patchGlobalApplicationCommand(command: Optional<ApplicationCommand, "name" | "description" | "options" | "default_permission">, options?: {
    headers?: Record<string, string>;
    applicationID?: Snowflake;
}): Promise<ApplicationCommand>;
export declare function deleteGlobalApplicationCommand(commandID: Snowflake, options?: {
    headers?: Record<string, string>;
    applicationID?: Snowflake;
}): Promise<boolean>;
export declare function getGuildApplicationCommands(guildID: Snowflake, options?: {
    headers?: Record<string, string>;
    applicationID?: Snowflake;
}): Promise<ApplicationCommand[]>;
export declare function postGuildApplicationCommand(guildID: Snowflake, command: Omit<ApplicationCommand, "id" | "application_id">, options?: {
    headers?: Record<string, string>;
    applicationID?: Snowflake;
}): Promise<ApplicationCommand>;
export declare function putGuildApplicationCommands(guildID: Snowflake, commands: ApplicationCommand[], options?: {
    headers?: Record<string, string>;
    applicationID?: Snowflake;
}): Promise<ApplicationCommand>;
export declare function patchGuildApplicationCommand(guildID: Snowflake, command: Optional<ApplicationCommand, "name" | "description" | "options" | "default_permission">, options?: {
    headers?: Record<string, string>;
    applicationID?: Snowflake;
}): Promise<ApplicationCommand>;
export declare function deleteGuildApplicationCommand(guildID: Snowflake, commandID: Snowflake, options?: {
    headers?: Record<string, string>;
    applicationID?: Snowflake;
}): Promise<boolean>;
