import { URL } from "url";
import Config from "./config";
import Client from "discord-request";
import { API_URL, } from "../definitions";
/**
 * https://discord.com/developers/docs/interactions/slash-commands#followup-messages
 */
// TODO: Test, Type, Document
export async function postWebhookMessage(interactionToken, data, options = {}) {
    const { applicationID = Config.getApplicationID(), headers = Config.getHeaders(), } = options;
    const url = new URL(`${API_URL}/webhooks/${applicationID}/${interactionToken}`);
    return Client.post(url, {
        headers,
        body: JSON.stringify(data),
    }, {
        route: "[GET] /webhooks/{application.id}/{interaction.token}",
        identifier: `${applicationID}${interactionToken}`,
    });
}
// TODO: Test, Type, Document
export async function patchWebhookMessage(interactionToken, id, data, options = {}) {
    const { applicationID = Config.getApplicationID(), headers = Config.getHeaders(), } = options;
    const url = new URL(`${API_URL}/webhooks/${applicationID}/${interactionToken}/messages/${id}`);
    return Client.patch(url, {
        headers,
        body: JSON.stringify(data),
    }, {
        route: `[PATCH] /webhooks/{application.id}/{interaction.token}/messages/${id === "@original" ? "@original" : "{message_id}"}`,
        identifier: `${applicationID}${interactionToken}`,
    });
}
// TODO: Test, Type, Document
export async function deleteWebhookMessage(interactionToken, id, options = {}) {
    const { applicationID = Config.getApplicationID(), headers = Config.getHeaders(), } = options;
    const url = new URL(`${API_URL}/webhooks/${applicationID}/${interactionToken}/messages/${id}`);
    const response = await Client.delete(url, {
        headers,
    }, {
        route: `[DELETE] /webhooks/{application.id}/{interaction.token}/messages/${id === "@original" ? "@original" : "{message_id}"}`,
        identifier: `${applicationID}${interactionToken}`,
    });
    return response.ok;
}
//# sourceMappingURL=interactions.js.map