import { ApplicationCommand, ApplicationCommandType } from "../definitions";
import Application from "../application";
import { InteractionKitCommand, Optional } from "../interfaces";
import ContextMenuInteraction, { ContextMenuApplicationCommandType } from "../interactions/application-commands/context-menu-interaction";
declare type ContextMenuArgs<T extends ContextMenuApplicationCommandType> = {
    name: string;
    type: T;
    defaultPermission?: boolean;
    handler: (interaction: ContextMenuInteraction<T>, application: Application) => unknown;
};
export default class ContextMenu<T extends ContextMenuApplicationCommandType> implements InteractionKitCommand<ContextMenuInteraction<T>> {
    #private;
    static readonly USER = ApplicationCommandType.USER;
    static readonly MESSAGE = ApplicationCommandType.MESSAGE;
    name: string;
    type: T;
    handler: (interaction: ContextMenuInteraction<T>, application: Application) => unknown;
    constructor({ name, type, handler, defaultPermission, }: ContextMenuArgs<T>);
    equals(schema: ApplicationCommand): boolean;
    serialize(): Optional<ApplicationCommand, "id" | "application_id">;
}
export {};
