import { ApplicationCommand, ApplicationCommandType } from "../definitions";
import Application from "../application";
import { Input } from "../components/inputs";
import { Optional, InteractionKitCommand } from "../interfaces";
import SlashCommandInteraction from "../interactions/application-commands/slash-command-interaction";
declare type CommandArgs = {
    name: string;
    description: string;
    defaultPermission?: boolean;
    options?: Input[];
    handler: (interaction: SlashCommandInteraction) => unknown;
};
export default class SlashCommand implements InteractionKitCommand<SlashCommandInteraction> {
    #private;
    readonly type = ApplicationCommandType.CHAT_INPUT;
    name: string;
    handler: (interaction: SlashCommandInteraction, application: Application) => unknown;
    constructor({ name, description, options, handler, defaultPermission, }: CommandArgs);
    group(): void;
    subcommand(): void;
    equals(schema: ApplicationCommand): boolean;
    serialize(): Optional<ApplicationCommand, "id" | "application_id">;
}
export {};
