var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _SlashCommand_description, _SlashCommand_defaultPermission, _SlashCommand_options;
import { ApplicationCommandType } from "../definitions";
export default class SlashCommand {
    constructor({ name, description, options, handler, defaultPermission = true, }) {
        this.type = ApplicationCommandType.CHAT_INPUT;
        _SlashCommand_description.set(this, void 0);
        _SlashCommand_defaultPermission.set(this, void 0);
        _SlashCommand_options.set(this, void 0);
        // TODO: Validate: 1-32 lowercase character name matching ^[\w-]{1,32}$
        this.name = name;
        __classPrivateFieldSet(this, _SlashCommand_description, description, "f");
        __classPrivateFieldSet(this, _SlashCommand_defaultPermission, defaultPermission, "f");
        this.handler = handler;
        __classPrivateFieldSet(this, _SlashCommand_options, new Map(), "f");
        options?.forEach((option) => {
            const key = option.name.toLowerCase();
            if (__classPrivateFieldGet(this, _SlashCommand_options, "f").has(key)) {
                throw new Error(`Option names must be unique (case insensitive). Duplicate name detected: ${key}`);
            }
            __classPrivateFieldGet(this, _SlashCommand_options, "f").set(key, option);
        });
    }
    group() {
        throw new Error("Unimplemented");
    }
    subcommand() {
        throw new Error("Unimplemented");
    }
    equals(schema) {
        if (this.name !== schema.name ||
            __classPrivateFieldGet(this, _SlashCommand_description, "f") !== schema.description ||
            __classPrivateFieldGet(this, _SlashCommand_defaultPermission, "f") !== schema.default_permission) {
            return false;
        }
        if (__classPrivateFieldGet(this, _SlashCommand_options, "f").size !== (schema.options?.length ?? 0)) {
            return false;
        }
        return (schema.options?.every((option) => __classPrivateFieldGet(this, _SlashCommand_options, "f").get(option.name)?.equals(option) ?? false) ?? true);
    }
    serialize() {
        const payload = {
            name: this.name,
            description: __classPrivateFieldGet(this, _SlashCommand_description, "f"),
        };
        if (!__classPrivateFieldGet(this, _SlashCommand_defaultPermission, "f")) {
            payload.default_permission = __classPrivateFieldGet(this, _SlashCommand_defaultPermission, "f");
        }
        // TODO: Sort these so that required options come first
        if (__classPrivateFieldGet(this, _SlashCommand_options, "f").size > 0) {
            payload.options = [];
            Array.from(__classPrivateFieldGet(this, _SlashCommand_options, "f").entries()).forEach(([_, value]) => {
                payload.options?.push(value.serialize());
            });
        }
        return payload;
    }
}
_SlashCommand_description = new WeakMap(), _SlashCommand_defaultPermission = new WeakMap(), _SlashCommand_options = new WeakMap();
//# sourceMappingURL=slash-command.js.map