var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _ButtonBase_style, _ButtonBase_label, _ButtonBase_emoji, _ButtonBase_disabled, _ButtonLink_url, _Button_customID;
import { ButtonStyle, ComponentType } from "../definitions";
class ButtonBase {
    constructor(options) {
        _ButtonBase_style.set(this, void 0);
        _ButtonBase_label.set(this, void 0);
        _ButtonBase_emoji.set(this, void 0);
        _ButtonBase_disabled.set(this, void 0);
        __classPrivateFieldSet(this, _ButtonBase_label, options.label, "f");
        __classPrivateFieldSet(this, _ButtonBase_emoji, options.emoji, "f");
        __classPrivateFieldSet(this, _ButtonBase_disabled, options.disabled, "f");
        __classPrivateFieldSet(this, _ButtonBase_style, options.style, "f");
    }
    get id() {
        return undefined;
    }
    get type() {
        return ComponentType.BUTTON;
    }
    setLabel(label) {
        __classPrivateFieldSet(this, _ButtonBase_label, label, "f");
        return this;
    }
    setEmoji(emoji) {
        __classPrivateFieldSet(this, _ButtonBase_emoji, emoji, "f");
        return this;
    }
    setDisabled(disabled) {
        __classPrivateFieldSet(this, _ButtonBase_disabled, disabled, "f");
        return this;
    }
    serialize() {
        const payload = {
            type: ComponentType.BUTTON,
        };
        if (__classPrivateFieldGet(this, _ButtonBase_style, "f") != null) {
            payload.style = __classPrivateFieldGet(this, _ButtonBase_style, "f");
        }
        if (__classPrivateFieldGet(this, _ButtonBase_label, "f") != null) {
            payload.label = __classPrivateFieldGet(this, _ButtonBase_label, "f");
        }
        if (__classPrivateFieldGet(this, _ButtonBase_emoji, "f") != null) {
            payload.emoji = __classPrivateFieldGet(this, _ButtonBase_emoji, "f");
        }
        if (__classPrivateFieldGet(this, _ButtonBase_disabled, "f") != null) {
            payload.disabled = __classPrivateFieldGet(this, _ButtonBase_disabled, "f");
        }
        return payload;
    }
    setStyle(style) {
        __classPrivateFieldSet(this, _ButtonBase_style, style, "f");
        return this;
    }
}
_ButtonBase_style = new WeakMap(), _ButtonBase_label = new WeakMap(), _ButtonBase_emoji = new WeakMap(), _ButtonBase_disabled = new WeakMap();
export class ButtonLink extends ButtonBase {
    constructor(options) {
        super({
            ...options,
            style: ButtonStyle.LINK,
        });
        _ButtonLink_url.set(this, void 0);
        __classPrivateFieldSet(this, _ButtonLink_url, options?.url, "f");
    }
    setURL(url) {
        __classPrivateFieldSet(this, _ButtonLink_url, url, "f");
        return this;
    }
    serialize() {
        const payload = super.serialize();
        payload.url = __classPrivateFieldGet(this, _ButtonLink_url, "f");
        return payload;
    }
}
_ButtonLink_url = new WeakMap();
export class Button extends ButtonBase {
    constructor(options) {
        super({
            ...options,
            style: options?.style ?? ButtonStyle.PRIMARY,
        });
        _Button_customID.set(this, void 0);
        __classPrivateFieldSet(this, _Button_customID, options?.customID, "f");
        this.handler = options?.handler;
    }
    get id() {
        return __classPrivateFieldGet(this, _Button_customID, "f");
    }
    setCustomID(customID) {
        __classPrivateFieldSet(this, _Button_customID, customID, "f");
        return this;
    }
    setStyle(style) {
        super.setStyle(style);
        return this;
    }
    setHandler(fn) {
        this.handler = fn;
        return this;
    }
    serialize() {
        const payload = super.serialize();
        if (__classPrivateFieldGet(this, _Button_customID, "f") != null) {
            payload.custom_id = __classPrivateFieldGet(this, _Button_customID, "f");
        }
        return payload;
    }
}
_Button_customID = new WeakMap();
//# sourceMappingURL=button.js.map