import { ApplicationCommandOptionChoice, SelectOption } from "../definitions";
import { Serializable } from "../interfaces";
declare type ChoiceType = ApplicationCommandOptionChoice | SelectOption;
export declare class Choices<T extends ChoiceType> implements Serializable {
    _choices: Map<string, T>;
    constructor(choices: Record<string, T>);
    static create<T extends ChoiceType, U extends Record<string, T>>(this: typeof Choices, choices: U): Choices<T> & U;
    serialize(): T[];
}
export declare class SelectOptionList extends Choices<SelectOption> {
    constructor(choices: Record<string, SelectOption["value"] | SelectOption>);
}
export declare class SlashChoiceList<T extends ApplicationCommandOptionChoice["value"]> extends Choices<ApplicationCommandOptionChoice> {
    constructor(choices: Record<string, T | (Omit<ApplicationCommandOptionChoice, "value"> & {
        value: T;
    })>);
}
export {};
