import type { Embed as EmbedDefinition, EmbedAuthor, EmbedField, EmbedFooter, EmbedImage, EmbedProvider, EmbedThumbnail, EmbedVideo } from "../definitions";
import type { Serializable } from "../interfaces";
export default class Embed implements Serializable {
    title: EmbedDefinition["title"];
    description: EmbedDefinition["description"];
    url: EmbedDefinition["url"];
    timestamp: EmbedDefinition["timestamp"];
    color: EmbedDefinition["color"];
    footer: EmbedFooter | undefined;
    image: EmbedImage | undefined;
    thumbnail: EmbedThumbnail | undefined;
    video: EmbedVideo | undefined;
    provider: EmbedProvider | undefined;
    author: EmbedAuthor | undefined;
    fields: EmbedField[];
    constructor(options?: EmbedDefinition);
    setTitle(title: EmbedDefinition["title"]): this;
    setDescription(description: EmbedDefinition["description"]): this;
    setURL(url: EmbedDefinition["url"]): this;
    setTimestamp(timestamp: EmbedDefinition["timestamp"]): this;
    setColor(color: EmbedDefinition["color"]): this;
    setFooter(footer: EmbedFooter): this;
    setImage(image: EmbedImage): this;
    setThumbnail(thumbnail: EmbedThumbnail): this;
    setProvider(provider: EmbedProvider): this;
    setAuthor(author: EmbedAuthor): this;
    addField(field: EmbedField): this;
    serialize(): EmbedDefinition;
}
