import SelectInteraction from "../interactions/message-components/select-interaction";
import Application from "../application";
import { Component, ComponentType } from "../definitions";
import { Executable, SerializableComponent } from "../interfaces";
import { SelectOptionList } from "./choices";
declare type SelectArgs = {
    handler: (event: SelectInteraction, application: Application) => unknown;
    customID: Component["custom_id"];
    min: Component["min_values"];
    max: Component["max_values"];
    options: SelectOptionList;
} & Omit<Component, "type" | "url" | "custom_id" | "components" | "min_values" | "max_values" | "options">;
export default class Select implements SerializableComponent, Executable<SelectInteraction> {
    #private;
    options: SelectArgs["options"];
    handler: SelectArgs["handler"];
    constructor(options: SelectArgs);
    get id(): string | undefined;
    get type(): ComponentType;
    setCustomID(customID: SelectArgs["customID"]): this;
    setPlaceholder(placeholder: SelectArgs["placeholder"]): this;
    setMin(min: SelectArgs["min"]): this;
    setMax(max: SelectArgs["max"]): this;
    setDisabled(disabled: SelectArgs["disabled"]): this;
    setHandler(fn: SelectArgs["handler"]): this;
    serialize(): Component;
}
export {};
