/**
 * These type definitions come from the official Discord API docs. They should
 * be defined with references back to the documentation section.
 */
/** @link https://discord.com/developers/docs/interactions/application-commands#application-command-object-application-command-types */
export var ApplicationCommandType;
(function (ApplicationCommandType) {
    ApplicationCommandType[ApplicationCommandType["CHAT_INPUT"] = 1] = "CHAT_INPUT";
    ApplicationCommandType[ApplicationCommandType["USER"] = 2] = "USER";
    ApplicationCommandType[ApplicationCommandType["MESSAGE"] = 3] = "MESSAGE";
})(ApplicationCommandType || (ApplicationCommandType = {}));
/** @link https://discord.com/developers/docs/interactions/slash-commands#application-command-object-application-command-option-type */
export var ApplicationCommandOptionType;
(function (ApplicationCommandOptionType) {
    ApplicationCommandOptionType[ApplicationCommandOptionType["SUB_COMMAND"] = 1] = "SUB_COMMAND";
    ApplicationCommandOptionType[ApplicationCommandOptionType["SUB_COMMAND_GROUP"] = 2] = "SUB_COMMAND_GROUP";
    ApplicationCommandOptionType[ApplicationCommandOptionType["STRING"] = 3] = "STRING";
    ApplicationCommandOptionType[ApplicationCommandOptionType["INTEGER"] = 4] = "INTEGER";
    ApplicationCommandOptionType[ApplicationCommandOptionType["BOOLEAN"] = 5] = "BOOLEAN";
    ApplicationCommandOptionType[ApplicationCommandOptionType["USER"] = 6] = "USER";
    ApplicationCommandOptionType[ApplicationCommandOptionType["CHANNEL"] = 7] = "CHANNEL";
    ApplicationCommandOptionType[ApplicationCommandOptionType["ROLE"] = 8] = "ROLE";
    ApplicationCommandOptionType[ApplicationCommandOptionType["MENTIONABLE"] = 9] = "MENTIONABLE";
})(ApplicationCommandOptionType || (ApplicationCommandOptionType = {}));
/** @link https://discord.com/developers/docs/interactions/slash-commands#application-command-permissions-object-application-command-permission-type */
export var ApplicationCommandPermissionType;
(function (ApplicationCommandPermissionType) {
    ApplicationCommandPermissionType[ApplicationCommandPermissionType["ROLE"] = 1] = "ROLE";
    ApplicationCommandPermissionType[ApplicationCommandPermissionType["USER"] = 2] = "USER";
})(ApplicationCommandPermissionType || (ApplicationCommandPermissionType = {}));
/** @link https://discord.com/developers/docs/interactions/slash-commands#interaction-object-interaction-request-type */
export var InteractionRequestType;
(function (InteractionRequestType) {
    InteractionRequestType[InteractionRequestType["PING"] = 1] = "PING";
    InteractionRequestType[InteractionRequestType["APPLICATION_COMMAND"] = 2] = "APPLICATION_COMMAND";
    InteractionRequestType[InteractionRequestType["MESSAGE_COMPONENT"] = 3] = "MESSAGE_COMPONENT";
})(InteractionRequestType || (InteractionRequestType = {}));
/** @link https://discord.com/developers/docs/interactions/slash-commands#interaction-response-object-interaction-callback-type */
export var InteractionCallbackType;
(function (InteractionCallbackType) {
    InteractionCallbackType[InteractionCallbackType["PONG"] = 1] = "PONG";
    InteractionCallbackType[InteractionCallbackType["CHANNEL_MESSAGE_WITH_SOURCE"] = 4] = "CHANNEL_MESSAGE_WITH_SOURCE";
    InteractionCallbackType[InteractionCallbackType["DEFERRED_CHANNEL_MESSAGE_WITH_SOURCE"] = 5] = "DEFERRED_CHANNEL_MESSAGE_WITH_SOURCE";
    InteractionCallbackType[InteractionCallbackType["DEFERRED_UPDATE_MESSAGE"] = 6] = "DEFERRED_UPDATE_MESSAGE";
    InteractionCallbackType[InteractionCallbackType["UPDATE_MESSAGE"] = 7] = "UPDATE_MESSAGE";
})(InteractionCallbackType || (InteractionCallbackType = {}));
//# sourceMappingURL=application-commands.js.map