/**
 * These type definitions come from the official Discord API docs. They should
 * be defined with references back to the documentation section.
 */
/** @link https://discord.com/developers/docs/resources/channel#allowed-mentions-object-allowed-mention-types */
export var AllowedMentionTypes;
(function (AllowedMentionTypes) {
    AllowedMentionTypes["ROLE"] = "roles";
    AllowedMentionTypes["USER"] = "users";
    AllowedMentionTypes["EVERYONE"] = "everyone";
})(AllowedMentionTypes || (AllowedMentionTypes = {}));
/** @link https://discord.com/developers/docs/resources/channel#channel-object-channel-types */
export var ChannelType;
(function (ChannelType) {
    ChannelType[ChannelType["GUILD_TEXT"] = 0] = "GUILD_TEXT";
    ChannelType[ChannelType["DM"] = 1] = "DM";
    ChannelType[ChannelType["GUILD_VOICE"] = 2] = "GUILD_VOICE";
    ChannelType[ChannelType["GROUP_DM"] = 3] = "GROUP_DM";
    ChannelType[ChannelType["GUILD_CATEGORY"] = 4] = "GUILD_CATEGORY";
    ChannelType[ChannelType["GUILD_NEWS"] = 5] = "GUILD_NEWS";
    ChannelType[ChannelType["GUILD_STORE"] = 6] = "GUILD_STORE";
    ChannelType[ChannelType["GUILD_NEWS_THREAD"] = 10] = "GUILD_NEWS_THREAD";
    ChannelType[ChannelType["GUILD_PUBLIC_THREAD"] = 11] = "GUILD_PUBLIC_THREAD";
    ChannelType[ChannelType["GUILD_PRIVATE_THREAD"] = 12] = "GUILD_PRIVATE_THREAD";
    ChannelType[ChannelType["GUILD_STAGE_VOICE"] = 13] = "GUILD_STAGE_VOICE";
})(ChannelType || (ChannelType = {}));
/** @link https://discord.com/developers/docs/resources/channel#channel-object-video-quality-modes */
export var VideoQualityMode;
(function (VideoQualityMode) {
    VideoQualityMode[VideoQualityMode["AUTO"] = 1] = "AUTO";
    VideoQualityMode[VideoQualityMode["FULL"] = 2] = "FULL";
})(VideoQualityMode || (VideoQualityMode = {}));
//# sourceMappingURL=channels.js.map