/**
 * These type definitions come from the official Discord API docs. They should
 * be defined with references back to the documentation section.
 */
import type { Emoji } from "./emoji";
/** @link https://discord.com/developers/docs/interactions/message-components#component-object-component-structure */
export declare type Component = {
    type: ComponentType;
    style?: ButtonStyle;
    label?: string;
    emoji?: Pick<Emoji, "id" | "name" | "animated">;
    custom_id?: string;
    url?: string;
    disabled?: boolean;
    options?: SelectOption[];
    placeholder?: string;
    min_values?: number;
    max_values?: number;
    components?: Component[];
};
/** @link https://discord.com/developers/docs/interactions/message-components#select-menu-object-select-option-structure */
export declare type SelectOption = {
    label: string;
    value: string;
    description?: string;
    emoji?: Emoji;
    default?: boolean;
};
/** @link https://discord.com/developers/docs/interactions/message-components#component-object-component-types */
export declare enum ComponentType {
    ACTION_ROW = 1,
    BUTTON = 2,
    SELECT = 3
}
/** @link https://discord.com/developers/docs/interactions/message-components#button-object-button-styles */
export declare enum ButtonStyle {
    PRIMARY = 1,
    SECONDARY = 2,
    SUCCESS = 3,
    DANGER = 4,
    LINK = 5
}
