/**
 * These type definitions come from the official Discord API docs. They should
 * be defined with references back to the documentation section.
 */
/** @link https://discord.com/developers/docs/resources/channel#embed-object */
export declare type Embed = {
    title?: string;
    type?: EmbedType;
    description?: string;
    url?: string;
    timestamp?: Date;
    color?: number;
    footer?: EmbedFooter;
    image?: EmbedImage;
    thumbnail?: EmbedThumbnail;
    video?: EmbedVideo;
    provider?: EmbedProvider;
    author?: EmbedAuthor;
    fields?: EmbedField[];
};
/** @link https://discord.com/developers/docs/resources/channel#embed-object-embed-types */
export declare enum EmbedType {
    RICH = 0,
    IMAGE = 1,
    VIDEO = 2,
    GIFV = 3,
    ARTICLE = 4,
    LINK = 5
}
/** @link https://discord.com/developers/docs/resources/channel#embed-object-embed-thumbnail-structure */
export declare type EmbedThumbnail = {
    url?: string;
    proxy_url?: string;
    height?: number;
    width?: number;
};
/** @link https://discord.com/developers/docs/resources/channel#embed-object-embed-video-structure */
export declare type EmbedVideo = {
    url?: string;
    proxy_url?: string;
    height?: number;
    width?: number;
};
/** @link https://discord.com/developers/docs/resources/channel#embed-object-embed-image-structure */
export declare type EmbedImage = {
    url?: string;
    proxy_url?: string;
    height?: number;
    width?: number;
};
/** @link https://discord.com/developers/docs/resources/channel#embed-object-embed-provider-structure */
export declare type EmbedProvider = {
    name?: string;
    url?: string;
};
/** @link https://discord.com/developers/docs/resources/channel#embed-object-embed-author-structure */
export declare type EmbedAuthor = {
    name?: string;
    url?: string;
    icon_url?: string;
    proxy_icon_url?: string;
};
/** @link https://discord.com/developers/docs/resources/channel#embed-object-embed-footer-structure */
export declare type EmbedFooter = {
    text: string;
    icon_url?: string;
    proxy_icon_url?: string;
};
/** @link https://discord.com/developers/docs/resources/channel#embed-object-embed-field-structure */
export declare type EmbedField = {
    name: string;
    value: string;
    inline?: boolean;
};
