import type { FastifyReply, FastifyRequest } from "fastify";
import { Interaction as InteractionDefinition, ApplicationCommandType } from "../../definitions";
import Application from "../../application";
import ApplicationCommandInteraction from "./application-command-interaction";
import { InteractionKitCommand } from "../../interfaces";
export declare type ContextMenuApplicationCommandType = Exclude<ApplicationCommandType, ApplicationCommandType.CHAT_INPUT>;
declare type MessageTargetType = {
    pinned: boolean;
};
declare type UserTargetType = {
    bot: boolean;
};
declare type TargetType<T extends ContextMenuApplicationCommandType> = T extends ApplicationCommandType.MESSAGE ? MessageTargetType : T extends ApplicationCommandType.USER ? UserTargetType : unknown;
export default class ContextMenuInteraction<T extends ContextMenuApplicationCommandType> extends ApplicationCommandInteraction {
    readonly commandType: T;
    readonly target: TargetType<T>;
    constructor(application: Application, command: InteractionKitCommand<ContextMenuInteraction<T>>, request: FastifyRequest<{
        Body: InteractionDefinition;
    }>, response: FastifyReply);
}
export {};
