import { ApplicationCommandType, } from "../../definitions";
import ApplicationCommandInteraction from "./application-command-interaction";
export default class ContextMenuInteraction extends ApplicationCommandInteraction {
    constructor(application, command, request, response) {
        super(application, request, response);
        const id = request.body.data?.target_id ?? "0";
        switch (request.body.data?.type) {
            case ApplicationCommandType.MESSAGE:
                // @ts-expect-error This is set at runtime but it's guaranteed to be the generic
                this.commandType = ApplicationCommandType.MESSAGE;
                // @ts-expect-error Same as above
                this.target = (request.body.data?.resolved?.messages?.[id] ??
                    {});
                break;
            case ApplicationCommandType.USER:
                // @ts-expect-error This is set at runtime but it's guaranteed to be the generic
                this.commandType = ApplicationCommandType.USER;
                // @ts-expect-error Same as above
                this.target = {
                    ...(request.body?.data?.resolved?.members?.[id] ?? {}),
                    ...(request.body?.data?.resolved?.users?.[id] ?? {}),
                };
                break;
            default:
                // TODO: Improve the error
                throw new Error("Unknown Context Menu Type");
        }
    }
}
//# sourceMappingURL=context-menu-interaction.js.map