/// <reference types="node" />
/// <reference types="node/http" />
/// <reference types="got/dist/source/core/utils/timed-out" />
import type { FastifyReply, FastifyRequest } from "fastify";
import { Interaction as InteractionDefinition, InteractionRequestType, Snowflake } from "../../definitions";
import Application from "../../application";
import { Interaction, InteractionMessageModifiers, InteractionReply } from "../../interfaces";
export default class MessageComponentInteraction implements Interaction {
    #private;
    readonly type = InteractionRequestType.MESSAGE_COMPONENT;
    readonly token: string;
    readonly response: FastifyReply;
    readonly customID: string;
    readonly messages: InteractionMessageModifiers;
    readonly channelID: Snowflake | undefined;
    readonly guildID: Snowflake | undefined;
    readonly member: Record<string, unknown> | undefined;
    readonly message: Record<string, unknown> | undefined;
    constructor(application: Application, request: FastifyRequest<{
        Body: InteractionDefinition;
    }>, response: FastifyReply);
    acknowledge(): FastifyReply<import("http").Server, import("http").IncomingMessage, import("http").ServerResponse, import("fastify/types/route").RouteGenericInterface, unknown>;
    defer(): FastifyReply<import("http").Server, import("http").IncomingMessage, import("http").ServerResponse, import("fastify/types/route").RouteGenericInterface, unknown>;
    reply({ message, embed, components, ephemeral, queue, }: InteractionReply): Promise<"@original" | import("node-fetch").Response>;
}
