var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _MessageComponentInteraction_application, _MessageComponentInteraction_replied;
import * as API from "../../api";
import { InteractionCallbackType, InteractionRequestType, } from "../../definitions";
import { PermissionFlags } from "../../definitions/messages";
import { isActionRow } from "../../components/action-row";
export default class MessageComponentInteraction {
    constructor(application, request, response) {
        this.type = InteractionRequestType.MESSAGE_COMPONENT;
        _MessageComponentInteraction_application.set(this, void 0);
        _MessageComponentInteraction_replied.set(this, void 0);
        __classPrivateFieldSet(this, _MessageComponentInteraction_application, application, "f");
        this.response = response;
        this.token = request.body.token;
        this.customID = request?.body?.data?.custom_id ?? "";
        // TODO: Make these records
        this.channelID = request.body.channel_id;
        this.guildID = request.body.guild_id;
        this.member = request.body.member;
        this.message = request.body.message;
        // TODO: Rename?
        this.messages = {
            edit: async (data, id = "@original") => API.patchWebhookMessage(this.token, id, data),
            delete: async (id = "@original") => API.deleteWebhookMessage(this.token, id),
        };
        __classPrivateFieldSet(this, _MessageComponentInteraction_replied, false, "f");
    }
    // TODO: Settle on acknowledge or defer
    acknowledge() {
        return this.defer();
    }
    defer() {
        return this.response.status(200).send({
            type: InteractionCallbackType.DEFERRED_CHANNEL_MESSAGE_WITH_SOURCE,
        });
    }
    async reply({ message, embed, components, ephemeral = false, queue = false, }) {
        const data = {};
        if (message != null) {
            data.content = message;
        }
        if (ephemeral) {
            data.flags = PermissionFlags.EPHEMERAL;
        }
        if (embed != null) {
            data.embeds = []
                .concat(embed)
                .map((item) => item.serialize());
        }
        if (components != null) {
            components.forEach((component) => {
                if (isActionRow(component)) {
                    component.components.forEach((child) => {
                        __classPrivateFieldGet(this, _MessageComponentInteraction_application, "f").addComponent(child);
                    });
                }
                else {
                    __classPrivateFieldGet(this, _MessageComponentInteraction_application, "f").addComponent(component);
                }
            });
            data.components = []
                .concat(components)
                .map((component) => component.serialize());
        }
        const payload = {
            type: InteractionCallbackType.CHANNEL_MESSAGE_WITH_SOURCE,
            data,
        };
        if (!__classPrivateFieldGet(this, _MessageComponentInteraction_replied, "f") && !queue) {
            __classPrivateFieldSet(this, _MessageComponentInteraction_replied, true, "f");
            await this.response.status(200).send(payload);
            return "@original";
        }
        // TODO: Verified this sends the ID back (we probably need to extract it)
        const id = await API.postWebhookMessage(this.token, data);
        return id;
    }
}
_MessageComponentInteraction_application = new WeakMap(), _MessageComponentInteraction_replied = new WeakMap();
//# sourceMappingURL=message-component-interaction.js.map