/// <reference types="node" />
import { URL } from "url";
import { Mentionable } from "../interfaces";
export declare function user(user: Mentionable): string;
export declare function nickname(user: Mentionable): string;
export declare function channel(channel: Mentionable): string;
export declare function role(role: Mentionable): string;
export declare function emoji(emoji: {
    name: string;
} & Mentionable, animated?: boolean): string;
export declare enum TimestampStyle {
    SHORT_TIME = "t",
    LONG_TIME = "T",
    SHORT_DATE = "d",
    LONG_DATE = "D",
    SHORT_DATETIME = "f",
    LONG_DATETIME = "F",
    RELATIVE = "R"
}
export declare function time(timestamp: number, type?: TimestampStyle): string;
export declare function bold(message: string): string;
export declare function italic(message: string): string;
export declare function strikethrough(message: string): string;
export declare function underline(message: string): string;
export declare function codeblock(message: string, language?: string): string;
export declare function inlineCode(message: string): string;
export declare function quote(message: string): string;
export declare function spoiler(message: string): string;
export declare function link(title: string, url: URL | string): string;
export declare function hideEmbed(link: URL | string): string;
