export function user(user) {
    return `<@${user.id}>`;
}
export function nickname(user) {
    return `<@!${user.id}>`;
}
export function channel(channel) {
    return `<#${channel.id}>`;
}
export function role(role) {
    return `<@&${role.id}>`;
}
export function emoji(emoji, animated = false) {
    if (animated) {
        return `<a:${emoji.name}:${emoji.id}>`;
    }
    return `<:${emoji.name}:${emoji.id}>`;
}
export var TimestampStyle;
(function (TimestampStyle) {
    TimestampStyle["SHORT_TIME"] = "t";
    TimestampStyle["LONG_TIME"] = "T";
    TimestampStyle["SHORT_DATE"] = "d";
    TimestampStyle["LONG_DATE"] = "D";
    TimestampStyle["SHORT_DATETIME"] = "f";
    TimestampStyle["LONG_DATETIME"] = "F";
    TimestampStyle["RELATIVE"] = "R";
})(TimestampStyle || (TimestampStyle = {}));
export function time(timestamp, type = TimestampStyle.SHORT_DATETIME) {
    return `<t:${timestamp}:${type}>`;
}
export function bold(message) {
    return `**${message}**`;
}
export function italic(message) {
    return `_${message}_`;
}
export function strikethrough(message) {
    return `~~${message}~~`;
}
export function underline(message) {
    return `__${message}__`;
}
export function codeblock(message, language) {
    // eslint-disable-next-line no-negated-condition
    const signature = language != null ? `${language}\n` : "";
    return `\`\`\`${signature}${message}\`\`\``;
}
export function inlineCode(message) {
    return `\`${message}\``;
}
export function quote(message) {
    return `>>> ${message}`;
}
export function spoiler(message) {
    return `||${message}||`;
}
export function link(title, url) {
    return `[${title}](${url.toString()})`;
}
export function hideEmbed(link) {
    return `<${link.toString()}>`;
}
//# sourceMappingURL=markdown.js.map