import { EPOCH } from "../definitions";
/**
 * Snowflake structure is defined here:
 * https://discord.com/developers/docs/reference#snowflakes-snowflake-id-format-structure-left-to-right
 */
export function getTimestamp(snowflake) {
    return new Date(Number((BigInt(snowflake) >> BigInt(22)) + BigInt(EPOCH)));
}
export function getWorkerID(snowflake) {
    return Number((BigInt(snowflake) & BigInt(0x3e0000)) >> BigInt(17));
}
export function getProcessID(snowflake) {
    return Number((BigInt(snowflake) & BigInt(0x1f000)) >> BigInt(12));
}
export function getIncrement(snowflake) {
    return Number(BigInt(snowflake) & BigInt(0xfff));
}
//# sourceMappingURL=snowflake.js.map